#ifndef __MEMORY_CPP__
#define __MEMORY_CPP__

#ifdef USE_MALLOC

#include <malloc.h>

#else

#define heapNEW GetProcessHeap()
//HANDLE heapNEW;

/*void InitHeap(void)
{
  heapNEW = GetProcessHeap();
}*/

void * __cdecl malloc(size_t size)
{
  return HeapAlloc(heapNEW, HEAP_ZERO_MEMORY, size);
}

void * __cdecl realloc(void *block, size_t size)
{
  if (block)
    return HeapReAlloc(heapNEW,HEAP_ZERO_MEMORY,block,size);
  else
    return HeapAlloc(heapNEW,HEAP_ZERO_MEMORY, size);
}

void __cdecl free(void *block)
{
  HeapFree(heapNEW,0,block);
}

#ifdef __cplusplus
void * __cdecl operator new(size_t size)
{
  return malloc(size);
}

void __cdecl operator delete(void *block)
{
  free(block);
}
#endif

#endif

#endif
